我是靠谱客的博主 独特网络,最近开发中收集的这篇文章主要介绍Super Jumping! Jumping! Jumping! --简单dp,觉得挺不错的,现在分享给大家,希望可以做个参考。

概述

Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now. 



The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path. 
Your task is to output the maximum value according to the given chessmen list. 
Input
Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N 
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int. 
A test case starting with 0 terminates the input and this test case is not to be processed. 
Output
For each case, print the maximum according to rules, and one line one case. 
Sample Input
3 1 3 2
4 1 2 3 4
4 3 3 2 1
0
Sample Output
4
10

3

分析:这道题题干那么一大堆,理解题意之后再结合样例就可以看出这道题其实就是求解最长上升子序列,

因为题目说棋可以走一步或者跳着走,和给你一堆序列然后然后让你找出最长子序列要求如出一辙啊,只不过求个和罢了

好吧,既然这样,我们直接套着模板写就可以啦,我最近刚开始接触dp,这样的题我还是要水水的。。。,

上代码:

import java.util.*;
public class Main {
static Scanner in = new Scanner(System.in);
static int[] chess = new int[1005];
static int[] dp = new int[1005];
static int n;
public static void main(String[] args) {
while(in.hasNext()){
n = in.nextInt();
if(n==0) break;
int ans =0 ;
Arrays.fill(dp, 0);
for(int i = 1;i<= n ;i++)
chess[i]=in.nextInt();
for(int i=1;i<=n;i++){
dp[i]=chess[i];
for(int j=1;j< i;j++){
if(chess[j]<chess[i]){
dp[i]=Math.max(dp[i], dp[j]+chess[i]);//状态转移方程
}
}
ans= Math.max(dp[i], ans);
}
System.out.println(ans);
}
}
}
反思:关于最XX子序列的题都可以套用这个模板,只要把判断条件改一下就好了,就是小于大于等于来回换着玩呗

最后

以上就是独特网络为你收集整理的Super Jumping! Jumping! Jumping! --简单dp的全部内容,希望文章能够帮你解决Super Jumping! Jumping! Jumping! --简单dp所遇到的程序开发问题。

如果觉得靠谱客网站的内容还不错,欢迎将靠谱客网站推荐给程序员好友。

本图文内容来源于网友提供,作为学习参考使用,或来自网络收集整理,版权属于原作者所有。
点赞(39)

评论列表共有 0 条评论

立即
投稿
返回
顶部